/**
 * Test for inheritance.
 * Runs with mocha.
 */

"use strict";

const apeman = require('apeman'),
    mkdirp = require('mkdirp'),
    assert = require('assert');

describe('inherit', ()=> {

    let mockApemanfile = require.resolve('../doc/mocks/mock-Apemanfile.js');

    before((done) => {
        mkdirp(require(mockApemanfile).$cwd, done);
    });


    it('Show tmpls.', (done) => {
        apeman.show("tmpls", {
            keysonly: true,
            configuration: mockApemanfile
        }, (err) => {
            assert.ifError(err);
            done();
        });
    });

    it('Show tasks.', (done) => {
        apeman.show("tasks", {
            keysonly: true,
            configuration: mockApemanfile
        }, (err) => {
            assert.ifError(err);
            done();
        });
    });

    it('Run tmpls.', (done) => {
        apeman.tmpl({
            configuration: mockApemanfile
        }, (err) => {
            assert.ifError(err);
            done();
        });
    });

    it('Run mkdir tasks.', (done) => {
        apeman.task('app:mkdir', {
            configuration: mockApemanfile
        }, (err) => {
            assert.ifError(err);
            done();
        });
    });

    it('Run render tasks.', (done) => {
        apeman.task('app:render', {
            configuration: mockApemanfile
        }, (err) => {
            assert.ifError(err);
            done();
        });
    });

    it('List watch tasks.', (done) => {
        apeman.task('wtch:list', {
            configuration: mockApemanfile
        }, (err) => {
            assert.ifError(err);
            done();
        });
    });
});
